package springapp.repository;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.springframework.orm.ibatis.support.SqlMapClientDaoSupport;

import springapp.domain.Product;

public class iBatisProductDao extends SqlMapClientDaoSupport implements ProductDao {

    /** Logger for this class and subclasses */
    protected final Log logger = LogFactory.getLog(getClass());

    @SuppressWarnings("unchecked")
	public List<Product> getProductList() {
        logger.info("Getting products!");
        
        List<Product> products = getSqlMapClientTemplate().queryForList("getProductList");

        return products;
    }

    public void saveProduct(Product prod) {
        logger.info("Saving product: " + prod.getDescription());
        
        int count = getSqlMapClientTemplate().update("saveProduct", prod);
        
        logger.info("Rows affected: " + count);
    }
}
